<script setup lang="ts">
import { useCustomerStore } from '@/stores/customer';
import { useReceiptStore } from '@/stores/receipt';
import { type Ref, inject, ref, onMounted, computed } from 'vue';
import { useUserStore } from '@/stores/user';
import { useStockStore } from '@/stores/checkstock';
const stockStore = useStockStore();
const userStore = useUserStore()
const receiptStore = useReceiptStore()
// let itemIndex = ref(-1);
function calculateItem(item: any) {
  return item.unit * item.price
}
// function formatDate(date: any) {
//   if (!date) {
//     return "Fucking Wrong";
//   }

//   const year = date.getFullYear();
//   const month = String(date.getMonth() + 1).padStart(2, "0");
//   const day = String(date.getDate()).padStart(2, "0");
//   return `${year}-${month}-${day}`;
// }

const randomDateRef = ref<Date | null>(null)

const generateRandomDate = (startDate: Date, endDate: Date) => {
  const startTimestamp = startDate.getTime()
  const endTimestamp = endDate.getTime()
  const randomTimestamp =
    startTimestamp + Math.random() * (endTimestamp - startTimestamp)
  const randomDate = new Date(randomTimestamp)

  return randomDate;
}

const updateRandomDate = () => {
  const startDate = new Date('2024-01-01')
  const endDate = new Date('2024-01-31')
  randomDateRef.value = generateRandomDate(startDate, endDate)
}

onMounted(() => {
  const startDate = new Date('2024-01-01')
  const endDate = new Date('2024-01-31')
  updateRandomDate()
})

const formattedRandomDate = computed(() => {
  return randomDateRef.value?.toLocaleString() || ''
})
</script>
<template>
  <v-dialog v-model="receiptStore.receiptDialog" persistent width="auto">
    <v-card>
      <v-card-title style="font-size: 30px; text-align: center;" > RECEIPT </v-card-title>

      <v-card-text>
        DATE: {{ formattedRandomDate || 'Not available' }} 
        <!-- {{ formatDate(stockStore.stocks[itemIndex]?.date) }} -->
      </v-card-text>
      <v-card-text>
        CASHIER : {{ userStore.currentUser?.fullName }}
      </v-card-text>

      <v-card-text style="text-align: center;">
        --------------------------------------------------------------------------------------
      </v-card-text>
      <v-row style="text-align: center;">
        <v-col> ITEM </v-col>
        <v-col> QTY </v-col>
        <v-col> AMT </v-col>
      </v-row>
      <v-card-text style="text-align: center;">
        --------------------------------------------------------------------------------------
      </v-card-text>
      <v-row style="padding-bottom: 0;" v-for="(item, index) in receiptStore.receiptItems" :key="index">
        <v-col style="text-align: center;">
          {{ item.name }}
          <v-card-text style="text-align: left: ;">
            <div :class="'detail'" v-if="item.products?.category === 'drink'">Type : {{
                        item.products?.subCategory }}
            </div>
            <div :class="'detail'" v-if="item.products?.category === 'drink'">Sweet level : {{
                          item.products?.sweetLevel }}
            </div>
            <div :class="'detail'" v-if="item.products?.category === 'drink'">Size : {{ 
                          item.products?.size }}
            </div>
          </v-card-text>
            
        </v-col>

          <v-col style="text-align: center;">{{ item.unit }}</v-col>
          <v-col style="text-align: center;">{{ calculateItem(item) }}</v-col>

      </v-row>
      <v-card-text style="text-align: center;">
        --------------------------------------------------------------------------------------</v-card-text>
      <v-card-text style="text-align: left;">
        PAYMENT TYPE : {{ receiptStore.receipt.PaymentType }}
      </v-card-text>
      <v-card-text style="text-align: left;">
        TOTAL : {{ receiptStore.receipt?.totalBefore }} บาท
      </v-card-text>
      <v-card-text style="text-align: left;">
        DISCOUNT : {{ (receiptStore.receipt.PromotionDiscount)+(receiptStore.receipt.customerDiscount)+(receiptStore.receipt.PointDiscount) }} บาท
      </v-card-text>
      <v-card-text style="text-align: left;">
        TOTAL AMOUNT : {{ receiptStore.receipt?.total }} บาท
      </v-card-text>
      <v-card-text style="text-align: center;">
        --------------------------------------------------------------------------------------
      </v-card-text>
      <v-card-title style="font-size: large; text-align: center;" >
         THANK YOU! 
      </v-card-title>

      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn 
          color=rgb(255,200,200) 
          variant="text" 
          @click="receiptStore.receiptDialog = false">ยกเลิก
        </v-btn>
        <v-btn
          color=rgb(255,200,200)
          variant="text"
          @click="() => {
            // updateRandomDate() 
            receiptStore.receiptDialog = false
            receiptStore.clear()
          }"
        >
          บันทึก
        </v-btn>
      </v-card-actions>
    </v-card> 
  </v-dialog>

  
</template>
